
import java.util.*;
import java.awt.geom.*;

public class SimplePointList2D extends PointList2D {
	private ArrayList points = new ArrayList();

	public SimplePointList2D() {
	}

	// Einfgen/Lschen/Finden eines Punktes
	public void insert(Point2D.Double point) {
		points.add(point.clone());
	}

	public boolean remove(Point2D.Double point) {
		return points.remove(point);
	}
	public boolean contains(Point2D.Double point) {
		return points.contains(point);
	}

	// Listet alle Punkte auf, die sich im angegebenen Bereich befinden
	public ArrayList findInRangeX(double xFrom, double xTo) {
		ArrayList inRange = new ArrayList();
		Iterator iter = points.iterator();
		while (iter.hasNext()) {
			Point2D.Double p = (Point2D.Double)iter.next();
			if ((p.x > xFrom) && (p.x < xTo)) {
				inRange.add(p.clone());
			}
		}
		return inRange;
	}

	public ArrayList findInRangeY(double yFrom, double yTo) {
		ArrayList inRange = new ArrayList();
		Iterator iter = points.iterator();
		while (iter.hasNext()) {
			Point2D.Double p = (Point2D.Double)iter.next();
			if ((p.y > yFrom) && (p.y < yTo)) {
				inRange.add(p.clone());
			}
		}
		return inRange;
	}

	// Listet alle Punkte auf, die sich in diesem Rechteck befinden
	public ArrayList findInRectangle(Rectangle2D.Double rect) {
		ArrayList inRange = new ArrayList();
		Iterator iter = points.iterator();
		while (iter.hasNext()) {
			Point2D.Double p = (Point2D.Double)iter.next();
			if (rect.contains(p)) {
				inRange.add(p.clone());
			}
		}
		return inRange;
	}

	// Sucht den am nchsten stehenden Punkt (sqrt(dx+dy) = Minimum)
	public Point2D.Double findNearest(Point2D.Double point) {
		Iterator iter = points.iterator();
		if (!iter.hasNext()) {
			return null;
		}
		Point2D.Double nearest = (Point2D.Double)iter.next();
		double minDistSq = nearest.distanceSq(point);
		while (iter.hasNext()) {
			Point2D.Double p = (Point2D.Double)iter.next();
			double distSq = p.distanceSq(point);
			if (distSq < minDistSq) {
				nearest = p;
				minDistSq = distSq;
			}
		}
		return (Point2D.Double)nearest.clone();
	}

	// Ausgabe aller Punkte (zum Testen)
	public void printAll() {
		Out.println("Number of points: " + points.size());
		Iterator iter = points.iterator();
		int i = 1;
		while (iter.hasNext()) {
			Point2D.Double p = (Point2D.Double)iter.next();
			Out.println(i + ": " + p.x + " / " + p.y);
			i ++;
		}
	}
}
